"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.remove = exports.fetchList = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const get_components_by_dir_1 = __importDefault(require("./get-components-by-dir"));
const path_1 = __importDefault(require("path"));
const getComponentsByDir = (0, get_components_by_dir_1.default)();
async function fetchList(dirPath) {
    const list = await getComponentsByDir(dirPath);
    if (list.length === 0)
        return [];
    const toRemove = list.map(folder => path_1.default.join(folder, 'node_modules'));
    return toRemove.filter(fs_extra_1.default.existsSync);
}
exports.fetchList = fetchList;
async function remove(list) {
    for (const item of list) {
        await fs_extra_1.default.remove(item);
    }
}
exports.remove = remove;
