"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const clean_require_1 = __importDefault(require("../../../utils/clean-require"));
const install_compiler_1 = __importDefault(require("./install-compiler"));
function getCompiler(options) {
    const { compilerDep, componentPath, logger, pkg } = options;
    const compilerPath = path_1.default.join(componentPath, 'node_modules', compilerDep);
    const compiler = (0, clean_require_1.default)(compilerPath, { justTry: true });
    if (compiler) {
        return Promise.resolve(compiler);
    }
    let dependency = compilerDep;
    if (pkg.devDependencies[compilerDep]) {
        dependency += `@${pkg.devDependencies[compilerDep]}`;
    }
    const installOptions = {
        compilerPath,
        componentPath,
        dependency,
        logger
    };
    return (0, install_compiler_1.default)(installOptions);
}
exports.default = getCompiler;
