"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const module_exists_1 = __importDefault(require("../../../utils/module-exists"));
function getMissingDependencies(dependencies = {}) {
    const missing = [];
    Object.entries(dependencies).forEach(([dependency, version]) => {
        const pathToModule = path_1.default.resolve('node_modules/', dependency);
        if (!(0, module_exists_1.default)(pathToModule)) {
            missing.push(`${dependency}@${version || 'latest'}`);
        }
    });
    return missing;
}
exports.default = getMissingDependencies;
