"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const clean_require_1 = __importDefault(require("../../../utils/clean-require"));
const is_template_valid_1 = __importDefault(require("../../../utils/is-template-valid"));
const npm = __importStar(require("../../../utils/npm-utils"));
const index_1 = __importDefault(require("../../../resources/index"));
async function installCompiler(options) {
    const { compilerPath, componentPath, dependency, logger } = options;
    logger.warn(index_1.default.messages.cli.INSTALLING_DEPS(dependency, componentPath));
    const npmOptions = {
        dependency,
        installPath: componentPath,
        save: false,
        silent: true,
        usePrefix: false
    };
    const errorMsg = 'There was a problem while installing the compiler';
    try {
        await npm.installDependency(npmOptions);
        logger.ok('OK');
        const compiler = (0, clean_require_1.default)(compilerPath, { justTry: true });
        if (!(0, is_template_valid_1.default)(compiler)) {
            throw errorMsg;
        }
        return compiler;
    }
    catch (err) {
        logger.err('FAIL');
        throw errorMsg;
    }
}
exports.default = installCompiler;
