/// <reference types="node" />
import path from 'path';
import { Component } from '../../types';
interface RegistryOptions {
    registry?: string;
}
export default function registry(opts?: RegistryOptions): {
    add(registry: string): Promise<void>;
    get(): Promise<string[]>;
    getApiComponentByHref(href: string): Promise<Component>;
    getComponentPreviewUrlByUrl(componentHref: string): Promise<string>;
    putComponent(options: {
        username?: string;
        password?: string;
        route: string;
        path: string;
    }): Promise<void>;
    remove(registry: string): Promise<void>;
};
export type RegistryCli = ReturnType<typeof registry>;
export {};
