"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const open_1 = __importDefault(require("open"));
const universalify_1 = require("universalify");
const index_1 = __importDefault(require("../../resources/index"));
const preview = ({ logger, registry }) => (0, universalify_1.fromPromise)(async (opts) => {
    try {
        const href = await registry.getComponentPreviewUrlByUrl(opts.componentHref);
        await (0, open_1.default)(href);
        return href;
    }
    catch (err) {
        logger.err(index_1.default.errors.cli.COMPONENT_HREF_NOT_FOUND);
        throw index_1.default.errors.cli.COMPONENT_HREF_NOT_FOUND;
    }
});
exports.default = preview;
