"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const universalify_1 = require("universalify");
const index_1 = __importDefault(require("../../resources/index"));
const registryLs = ({ registry, logger }) => 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
(0, universalify_1.fromPromise)(async (_opts) => {
    try {
        const registries = await registry.get();
        logger.warn(index_1.default.messages.cli.REGISTRY_LIST);
        if (registries.length === 0) {
            const err = index_1.default.errors.cli.REGISTRY_NOT_FOUND;
            logger.err(err);
            throw err;
        }
        registries.forEach(registryLocation => logger.ok(registryLocation));
        return registries;
    }
    catch (err) {
        logger.err(index_1.default.errors.generic(String(err)));
        throw err;
    }
});
exports.default = registryLs;
