"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const safe_1 = __importDefault(require("colors/safe"));
const logFns = {
    // eslint-disable-next-line no-console
    writeLn: console.log,
    write: (msg) => process.stdout.write(msg.toString())
};
const log = (msg, color, keepLine) => logFns[keepLine ? 'write' : 'writeLn'](color ? safe_1.default[color](msg) : msg);
const logger = {
    err: (msg, keepLine) => log(msg, 'red', !!keepLine),
    log: (msg, keepLine) => log(msg, null, !!keepLine),
    ok: (msg, keepLine) => log(msg, 'green', !!keepLine),
    warn: (msg, keepLine) => log(msg, 'yellow', !!keepLine)
};
exports.default = logger;
