"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const resources_1 = __importDefault(require("../../resources"));
let subscriptions = {};
const eventsHandler = {
    fire(eventName, eventData) {
        if (subscriptions[eventName]) {
            subscriptions[eventName].forEach(callback => {
                callback(eventData);
            });
        }
    },
    on(eventName, callback) {
        if (typeof callback !== 'function') {
            throw resources_1.default.errors.registry.CONFIGURATION_ONREQUEST_MUST_BE_FUNCTION;
        }
        if (!subscriptions[eventName]) {
            subscriptions[eventName] = [];
        }
        subscriptions[eventName].push(callback);
    },
    off(eventName, callback) {
        if (typeof callback !== 'function') {
            throw resources_1.default.errors.registry.CONFIGURATION_OFFREQUEST_MUST_BE_FUNCTION;
        }
        if (subscriptions[eventName]) {
            subscriptions[eventName] = subscriptions[eventName].filter(sub => sub !== callback);
        }
    },
    reset() {
        subscriptions = {};
    }
};
exports.default = eventsHandler;
