"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const oc_template_es6_1 = __importDefault(require("oc-template-es6"));
const oc_template_handlebars_1 = __importDefault(require("oc-template-handlebars"));
const oc_template_jade_1 = __importDefault(require("oc-template-jade"));
const lodash_1 = __importDefault(require("lodash"));
function registerTemplates(extraTemplates, dev = false) {
    const coreTemplates = [
        oc_template_es6_1.default,
        oc_template_jade_1.default,
        oc_template_handlebars_1.default
    ];
    const templates = lodash_1.default.union(coreTemplates, extraTemplates);
    const templatesHash = templates.reduce((hash, template) => {
        const type = template.getInfo().type;
        hash[type] = template;
        return hash;
    }, {});
    const templatesInfo = templates.map(template => {
        const { externals, ...rest } = template.getInfo();
        return {
            ...rest,
            externals: externals.map(({ url, devUrl, ...rest }) => ({
                ...rest,
                url: dev && devUrl ? devUrl : url
            }))
        };
    });
    return {
        templatesHash,
        templatesInfo
    };
}
exports.default = registerTemplates;
