"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const resources_1 = __importDefault(require("../../../resources"));
function packageJsonValidator(pkgDetails) {
    if (pkgDetails.packageJson.name !== pkgDetails.componentName) {
        return {
            isValid: false,
            error: resources_1.default.errors.registry.COMPONENT_PUBLISHNAME_CONFLICT
        };
    }
    let result = pkgDetails.customValidator(pkgDetails.packageJson);
    if (typeof result === 'boolean') {
        result = { isValid: result };
        if (!result.isValid) {
            result.error = 'unknown';
        }
    }
    return result;
}
exports.default = packageJsonValidator;
