"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function pluginsRequirements(componentRequirements, registryPlugins) {
    const missing = [];
    const requiredPlugins = Array.isArray(componentRequirements)
        ? componentRequirements
        : Object.keys(componentRequirements || {});
    for (const requiredPlugin of requiredPlugins) {
        if (!registryPlugins ||
            !Object.keys(registryPlugins).includes(requiredPlugin)) {
            missing.push(requiredPlugin);
        }
    }
    if (missing.length) {
        return {
            isValid: false,
            missing: missing
        };
    }
    return { isValid: true };
}
exports.default = pluginsRequirements;
