"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function uploadedPackage(input) {
    const returnError = function (message) {
        return {
            isValid: false,
            message: message || 'uploaded package is not valid'
        };
    };
    if (!input || typeof input !== 'object' || Object.keys(input).length === 0) {
        return returnError('empty');
    }
    if (Object.keys(input).length !== 1) {
        return returnError('not_valid');
    }
    const file = input[0];
    const validTypes = ['application/gzip', 'application/octet-stream'];
    if (!validTypes.includes(file.mimetype) ||
        file.truncated ||
        file.filename.indexOf('.tar.gz') < 0) {
        return returnError('not_valid');
    }
    return { isValid: true, files: input };
}
exports.default = uploadedPackage;
