"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateNewVersion = exports.getAvailableVersion = void 0;
const semver_1 = __importDefault(require("semver"));
const semver_extra_1 = __importDefault(require("semver-extra"));
function getAvailableVersion(requestedVersion, availableVersions) {
    if (typeof requestedVersion === 'undefined') {
        requestedVersion = '';
    }
    const version = semver_1.default.maxSatisfying(availableVersions, requestedVersion) || undefined;
    const max = semver_extra_1.default.max(availableVersions);
    const isLatest = requestedVersion === '';
    return version || (isLatest && max) || undefined;
}
exports.getAvailableVersion = getAvailableVersion;
function validateNewVersion(requestedVersion, availableVersions) {
    return !availableVersions.includes(requestedVersion);
}
exports.validateNewVersion = validateNewVersion;
