"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const multer_1 = __importDefault(require("multer"));
function fileUpload(req, res, next) {
    if (res.conf.local) {
        return next();
    }
    const normaliseFileName = (x) => x.replace('.tar.gz', '').replace(/\W+/g, '-').toLowerCase();
    const upload = (0, multer_1.default)({
        limits: {
            fieldSize: 10
        },
        storage: multer_1.default.diskStorage({
            destination: res.conf.tempDir,
            filename: (_req, file, cb) => cb(null, `${normaliseFileName(file.originalname)}-${Date.now()}.tar.gz`)
        })
    });
    return upload.any()(req, res, next);
}
exports.default = fileUpload;
