"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const get_available_dependencies_1 = __importDefault(require("./helpers/get-available-dependencies"));
function dependencies(conf) {
    return function (_req, res) {
        if (res.conf.discovery) {
            const dependencies = (0, get_available_dependencies_1.default)(conf.dependencies).map(({ core, name, version }) => {
                const dep = {
                    name,
                    core
                };
                if (!core && version) {
                    // In the future this could be multiple versions
                    dep.versions = [version];
                }
                return dep;
            });
            res.status(200).json(dependencies);
        }
        else {
            res.status(401);
        }
    };
}
exports.default = dependencies;
