"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function applyDefaultValues(requestParameters = {}, expectedParameters = {}) {
    const optionalParametersWithDefaults = Object.entries(expectedParameters).filter((params) => !params[1].mandatory && typeof params[1].default !== 'undefined');
    optionalParametersWithDefaults.forEach(([expectedParameterName, expectedParameter]) => {
        const param = requestParameters[expectedParameterName];
        if (param === null || param === undefined) {
            requestParameters[expectedParameterName] = expectedParameter.default;
        }
    });
    return requestParameters;
}
exports.default = applyDefaultValues;
