"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getComponentRetrievingInfo(options) {
    const eventData = {
        headers: options.headers,
        name: options.name,
        parameters: options.parameters,
        requestVersion: options.version || '',
        duration: 0
    };
    const start = process.hrtime();
    return {
        extend(obj) {
            Object.assign(eventData, obj);
        },
        getData() {
            const delta = process.hrtime(start);
            const nanosec = delta[0] * 1e9 + delta[1];
            eventData.duration = nanosec / 1e3;
            return eventData;
        }
    };
}
exports.default = getComponentRetrievingInfo;
