"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const date_stringify_1 = __importDefault(require("../../../utils/date-stringify"));
function getComponentsHistory(history) {
    const result = [];
    for (const [name, versions] of Object.entries(history.components)) {
        for (const [version, details] of Object.entries(versions)) {
            result.push({
                name,
                publishDate: details.publishDate,
                version
            });
        }
    }
    return result
        .sort((a, b) => b.publishDate - a.publishDate)
        .map(x => ({
        name: x.name,
        version: x.version,
        publishDate: !x.publishDate
            ? 'Unknown'
            : (0, date_stringify_1.default)(new Date(x.publishDate))
    }));
}
exports.default = getComponentsHistory;
