"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const got_1 = __importDefault(require("got"));
async function isUrlDiscoverable(url) {
    try {
        const res = await (0, got_1.default)(url, {
            headers: { accept: 'text/html' }
        });
        const isHtml = !!res.headers['content-type']?.includes('text/html');
        return {
            isDiscoverable: isHtml
        };
    }
    catch (err) {
        return { isDiscoverable: false };
    }
}
exports.default = isUrlDiscoverable;
