"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const form_data_1 = __importDefault(require("form-data"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const got_1 = __importDefault(require("got"));
async function put(urlPath, files, headers) {
    const form = new form_data_1.default();
    if (!Array.isArray(files)) {
        files = [files];
    }
    files.forEach(file => {
        const fileName = path_1.default.basename(file);
        form.append(fileName, fs_extra_1.default.createReadStream(file));
    });
    const res = await (0, got_1.default)(urlPath, {
        headers: { ...headers, ...form.getHeaders() },
        method: 'PUT',
        body: form
    });
    if (res.statusCode !== 200) {
        throw res.body;
    }
    return res.body;
}
exports.default = put;
